
#ifndef __DEMO_APP_H
#define __DEMO_APP_H

#include <d3dx8math.h>
#include "dxutils/D3DApp.h"
#include "dxutils/D3DFont.h"
#include "engine/Camera.h"
#include "DXObject.h"


class CResources;
class CBoiler;
class CFluid;


class CDemoApp : public CD3DApplication {
public:
    CDemoApp();
	~CDemoApp();
	
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT FrameMove();
    virtual HRESULT Render();
	
    virtual LRESULT MsgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
	
private:
	void	resetCamera();
	void	updateCamera();
	void	calcTemperatures( float& average, float& bottom, float& top ) const;
	
private:
	CDXObjectContainer	mObjects;
    CD3DFont*		mFontMain;
    CD3DFont*		mFontSmall;
	CResources*		mResources;
	
	bool			mKeys[256];

	bool			mShowingHelp;

	CCamera			mCamera;
	D3DXVECTOR3		mCameraSphericalCoords;
	D3DXVECTOR3		mCameraDelta;

	// water
	CBoiler*		mBoiler;
	CFluid*			mFluid;
};


#endif
